package dev.dao;

import dev.database.DatabaseConnection;
import dev.model.OrderDetail;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class OrderDetailDao
{
    public void save(OrderDetail detail)
    {
        String sql =
                """
                INSERT INTO order_details
                (order_id, menu_item_id, quantity, price)
                VALUES (?, ?, ?, ?)
                """;

        try (Connection connection = DatabaseConnection.getConnection();
             PreparedStatement ps = connection.prepareStatement(sql))
        {
            ps.setInt(1, detail.getOrderId());
            ps.setInt(2, detail.getMenuItemId());
            ps.setInt(3, detail.getQuantity());
            ps.setDouble(4, detail.getPrice());
            ps.executeUpdate();

        }
        catch (SQLException e)
        {
            e.printStackTrace();
        }
    }

    public List<OrderDetail> findByOrderId(int orderId)
    {
        List<OrderDetail> details = new ArrayList<>();

        String sql =
                """
                SELECT *
                FROM order_details
                WHERE order_id = ?
                """;

        try (Connection connection = DatabaseConnection.getConnection();
             PreparedStatement ps = connection.prepareStatement(sql))
        {
            ps.setInt(1, orderId);
            ResultSet rs = ps.executeQuery();

            while (rs.next())
            {
                OrderDetail detail = new OrderDetail();
                detail.setId(rs.getInt("id"));
                detail.setOrderId(rs.getInt("order_id"));
                detail.setMenuItemId(rs.getInt("menu_item_id"));
                detail.setQuantity(rs.getInt("quantity"));
                detail.setPrice(rs.getDouble("price"));

                details.add(detail);
            }

        }
        catch (SQLException e)
        {
            e.printStackTrace();
        }

        return details;
    }
}